<template>
  <div>
    <PropertyRenderer
      v-for="entry in mapping"
      :key="entry.predicate.value"
      :application-profile="applicationProfile"
      :definition="definition"
      :entry="entry"
      :readonly="readonlyComputed"
      :selected-property="selectedProperty"
      @updateDefinition="updateDefinition"
      @updateProperty="updateProperty"
    />
    <div class="mb-2">
      <label
        id="propertyTypesLabel"
        class="form-label d-inline-flex gap-1 align-items-center"
        for="propertyTypes"
        >{{ $t("propertyTypesLabel") }} <i-bi-question-circle-fill
      /></label>
      <b-tooltip
        :target="'propertyTypesLabel'"
        triggers="hover"
        noninteractive
        >{{ $t("propertyTypesDescription") }}</b-tooltip
      >
      <b-form-select
        id="propertyTypes"
        v-model="selectedTypePredicate"
        :placeholder="$t('propertyTypesLabel')"
        :disabled="readonlyComputed"
        @change="switchTypes"
      >
        <b-form-select-option
          v-for="type in types"
          :key="type.predicate.value"
          :value="type.predicate"
        >
          {{ $t(type.labelKey) }}
        </b-form-select-option>
      </b-form-select>
    </div>
    <PropertyRenderer
      v-if="selectedType"
      :application-profile="applicationProfile"
      :definition="definition"
      :entry="selectedType"
      :readonly="readonlyComputed"
      :selected-property="selectedProperty"
      @updateDefinition="updateDefinition"
      @updateProperty="updateProperty"
    />
    <b-collapse id="collapse-qualified" v-model="qualifiedVisible" class="mt-2">
      <PropertyRenderer
        v-for="entry in qualifiedProperties"
        :key="entry.predicate.value"
        :application-profile="applicationProfile"
        :definition="definition"
        :entry="entry"
        :readonly="readonlyComputed"
        :selected-property="selectedProperty"
        @updateDefinition="updateDefinition"
        @updateProperty="updateProperty"
      />
    </b-collapse>
    <div class="d-grid gap-0">
      <b-button
        :class="(stringVisible ? null : 'collapsed') + ' collapseButton'"
        :aria-expanded="stringVisible ? 'true' : 'false'"
        aria-controls="collapse-string"
        @click="stringVisible = !stringVisible"
      >
        {{ $t("stringVisible") }}
      </b-button>
      <b-collapse id="collapse-string" v-model="stringVisible" class="mt-2">
        <b-card>
          <PropertyRenderer
            v-for="entry in stringProperties"
            :key="entry.predicate.value"
            :application-profile="applicationProfile"
            :definition="definition"
            :entry="entry"
            :readonly="readonlyComputed"
            :selected-property="selectedProperty"
            @updateDefinition="updateDefinition"
            @updateProperty="updateProperty"
          />
        </b-card>
      </b-collapse>
      <b-button
        :class="(valueVisible ? null : 'collapsed') + ' collapseButton'"
        :aria-expanded="valueVisible ? 'true' : 'false'"
        aria-controls="collapse-value"
        @click="valueVisible = !valueVisible"
      >
        {{ $t("valueVisible") }}
      </b-button>
      <b-collapse id="collapse-value" v-model="valueVisible" class="mt-2">
        <b-card>
          <PropertyRenderer
            v-for="entry in valueProperties"
            :key="entry.predicate.value"
            :application-profile="applicationProfile"
            :definition="definition"
            :entry="entry"
            :readonly="readonlyComputed"
            :selected-property="selectedProperty"
            @updateDefinition="updateDefinition"
            @updateProperty="updateProperty"
          />
        </b-card>
      </b-collapse>
      <b-button
        :class="
          (administrativeVisible ? null : 'collapsed') + ' collapseButton'
        "
        :aria-expanded="administrativeVisible ? 'true' : 'false'"
        aria-controls="collapse-value"
        @click="administrativeVisible = !administrativeVisible"
      >
        {{ $t("administrativeVisible") }}
      </b-button>
      <b-collapse
        id="collapse-administrative"
        v-model="administrativeVisible"
        class="mt-2"
      >
        <b-card>
          <PropertyRenderer
            v-for="entry in administrativeProperties"
            :key="entry.predicate.value"
            :application-profile="applicationProfile"
            :definition="definition"
            :entry="entry"
            :readonly="readonlyComputed"
            :selected-property="selectedProperty"
            @updateDefinition="updateDefinition"
            @updateProperty="updateProperty"
          />
        </b-card>
      </b-collapse>
      <b-button
        :class="(propertyPairVisible ? null : 'collapsed') + ' collapseButton'"
        :aria-expanded="propertyPairVisible ? 'true' : 'false'"
        aria-controls="collapse-value"
        @click="propertyPairVisible = !propertyPairVisible"
      >
        {{ $t("propertyPairVisible") }}
      </b-button>
      <b-collapse
        id="collapse-administrative"
        v-model="propertyPairVisible"
        class="mt-2"
      >
        <b-card>
          <PropertyRenderer
            v-for="entry in propertyPairProperties"
            :key="entry.predicate.value"
            :application-profile="applicationProfile"
            :definition="definition"
            :entry="entry"
            :readonly="readonlyComputed"
            :selected-property="selectedProperty"
            @updateDefinition="updateDefinition"
            @updateProperty="updateProperty"
          />
        </b-card>
      </b-collapse>
    </div>
  </div>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type { ShaclProperty } from "@/types/shape-properties";
import type { Dataset, Literal, Quad_Object, Quad_Subject } from "@rdfjs/types";

import { defineComponent, type PropType } from "vue";

import factory from "rdf-ext";

import {
  getObject,
  prefixes,
  updateListObject,
  updateLocaleObject,
  updateNodeImport,
  updateObject,
  updateObjects,
} from "@/util/linkedData";

import {
  administrativeShaclProperties,
  defaultShaclProperties,
  propertyPairProperties,
  qualifiedProperties,
  shaclDatatypeProperty,
  shaclPropertyTypes,
  stringShaclProperties,
  valueShaclProperties,
} from "@/util/shaclProperties";

export default defineComponent({
  name: "PropertyDefinition",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
    selectedProperty: {
      required: true,
      type: Object as PropType<Quad_Subject>,
    },
  },
  data() {
    return {
      administrativeProperties: administrativeShaclProperties,
      administrativeVisible: false,
      mapping: defaultShaclProperties,
      propertyPairProperties: propertyPairProperties,
      propertyPairVisible: false,
      qualifiedProperties: qualifiedProperties,
      selectedTypePredicate: shaclDatatypeProperty.predicate,
      stringProperties: stringShaclProperties,
      stringVisible: false,
      types: shaclPropertyTypes,
      valueProperties: valueShaclProperties,
      valueVisible: false,
    };
  },
  computed: {
    qualifiedVisible(): boolean {
      if (this.selectedType) {
        return (
          this.selectedType.predicate.value ===
          prefixes.sh + "qualifiedValueShape"
        );
      }
      return false;
    },
    readonlyComputed(): boolean {
      return (
        this.readonly || this.definition.match(this.selectedProperty).size === 0
      );
    },
    selectedType(): ShaclProperty | undefined {
      return this.types.find(
        (type) => type.predicate === this.selectedTypePredicate,
      );
    },
  },
  watch: {
    selectedProperty() {
      this.evalType();
    },
  },
  mounted() {
    this.evalType();
  },
  methods: {
    evalType() {
      const typeWithValue = this.types.filter(
        (type) => this.getValue(type) !== "",
      );
      if (typeWithValue.length > 0) {
        this.selectedTypePredicate = typeWithValue[0].predicate;
      }
    },
    getValue(entry: ShaclProperty) {
      const matches = entry.localized
        ? getObject(
            this.selectedProperty,
            entry.predicate,
            this.definition,
            this.$i18n.locale,
          )
        : getObject(this.selectedProperty, entry.predicate, this.definition);

      // If a match is found, it is assumed to only have one. Therefore the first result is returned.
      for (const matchedValue of matches) {
        return matchedValue.object.value;
      }
      return "";
    },
    switchTypes() {
      for (const type of this.types.filter(
        (type) => type !== this.selectedType,
      )) {
        if (type.type === "list") {
          this.updateProperty(type, [], false);
        } else {
          this.updateProperty(type, "", false);
        }
      }
      this.updateDefinition();
    },
    updateDefinition() {
      this.$emit("updateDefinition");
    },
    updateProperty(
      entry: ShaclProperty,
      value: string | Quad_Object[],
      sendUpdate = true,
      locale?: string,
    ) {
      if (Array.isArray(value)) {
        if (entry.listType === "linked") {
          updateListObject(
            this.selectedProperty,
            entry.predicate,
            value,
            this.definition,
          );
        } else {
          updateObjects(
            this.selectedProperty,
            entry.predicate,
            value,
            this.definition,
          );
        }
      } else {
        if (entry.localized) {
          updateLocaleObject(
            this.selectedProperty,
            entry.predicate,
            factory.literal(value, locale ?? this.$i18n.locale),
            locale ?? this.$i18n.locale,
            this.definition,
          );
        } else {
          let object: Quad_Object;
          if (entry.type === "url") {
            object = factory.namedNode(value);
          } else {
            object = factory.literal(value) as Literal;
            if (entry.type === "number") {
              object.datatype = factory.namedNode(prefixes.xsd + "integer");
            }
            if (entry.type === "boolean") {
              object.datatype = factory.namedNode(prefixes.xsd + "boolean");
            }
          }
          updateObject(
            this.selectedProperty,
            entry.predicate,
            object,
            this.definition,
          );
          if (entry.searchType === "node") {
            updateNodeImport(this.applicationProfile, this.definition);
          }
        }
      }
      if (sendUpdate) {
        this.updateDefinition();
      }
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
label {
  margin-top: 0.325rem;
}
.collapseButton {
  margin-top: 1rem;
  margin-bottom: 0.7rem;
}
</style>
